package egg_energy

import (
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/enum"
	md2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/md"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/rule"
	enum2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/enum"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/md"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/svc"
	egg_system_rules "code.fnuoos.com/EggPlanet/egg_system_rules.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/EggPlanet/egg_system_rules.git/utils/logx"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"fmt"
	"xorm.io/xorm"
)

// ActivityCoinAutoExchangeEggTeamEnergy 团队蛋蛋积分【开始】兑换成团队蛋蛋能量
func ActivityCoinAutoExchangeEggTeamEnergy(engine *xorm.Engine, req md.EggEnergyStructForAutoExchangeGreenEnergy, ch *rabbit.Channel) (err error) {
	session := engine.NewSession()
	defer func() {
		session.Close()
		if err := recover(); err != nil {
			_ = zhios_order_relate_logx.Error(err)
		}
	}()
	session.Begin()

	eggEnergyCoreData, cb, err := svc.GetEggEnergyCoreData(engine)
	if err != nil {
		return err
	}
	if cb != nil {
		defer cb() // 释放锁
	}

	//1、计算涨价公式
	err1, calcPriceIncreaseFormulaResp := CalcPriceIncreaseFormula(req.AutoExchangeNumsAmount, eggEnergyCoreData)
	if err1 != nil {
		_ = session.Rollback()
		return err1
	}

	//2、更改动态数据
	err = DealAvailableEggEnergyCoin(session, int(enum2.TeamActivePointRedemption), eggEnergyCoreData, md.DealAvailableEggEnergyCoinReq{
		Amount:                 calcPriceIncreaseFormulaResp.GetEggEnergyNums,
		AmountFee:              "",
		BeforePrice:            calcPriceIncreaseFormulaResp.BeforePrice,
		AfterPrice:             calcPriceIncreaseFormulaResp.AfterPrice,
		BeforePlanetTotalValue: calcPriceIncreaseFormulaResp.BeforePlanetTotalValue,
		AfterPlanetTotalValue:  calcPriceIncreaseFormulaResp.AfterPlanetTotalValue,
		BeforeEnergyTotalNums:  calcPriceIncreaseFormulaResp.BeforeEnergyTotalNums,
		AfterEnergyTotalNums:   calcPriceIncreaseFormulaResp.AfterEnergyTotalNums,
	})
	if err != nil {
		fmt.Println("ActivityCoinAutoExchangeEggTeamEnergy:::::err111:::", err)
		_ = session.Rollback()
		return err
	}

	//3、增加用户对应蛋蛋能量数量
	err = rule.DealUserVirtualCoin(session, md2.DealUserVirtualCoinReq{
		Kind:         "add",
		Title:        enum.TeamEggGetByEnergyEggPointCoin.String(),
		TransferType: int(enum.TeamEggGetByEnergyEggPointCoin),
		CoinId:       req.EnergyCoinId,
		Uid:          req.Uid,
		Amount:       egg_system_rules.StrToFloat64(calcPriceIncreaseFormulaResp.GetEggEnergyNums),
	})
	if err != nil {
		fmt.Println("ActivityCoinAutoExchangeEggTeamEnergy:::::err222:::", err)
		_ = session.Rollback()
		return
	}

	return session.Commit()
}
