package md

const EggEnergyExchange = "egg.energy"

const (
	EggEnergyRoutKeyForStarLevelDividend                = "star_level_dividend"                  // 星级分红
	EggEnergyRoutKeyForSettlementPublicGiveActivityCoin = "settlement_public_give_activity_coin" // 计算观看激励视屏得到活跃积分
	EggEnergyRoutKeyForReadyExchangeGreenEnergyToPerson = "ready_exchange_egg_energy_to_person"  // 准备兑换个人蛋蛋能量
	EggEnergyRoutKeyForStartExchangeGreenEnergyToPerson = "start_exchange_egg_energy_to_person"  // 开始兑换个人蛋蛋能量
	EggEnergyRoutKeyForAutoExchangeGreenEnergyToPerson  = "auto_exchange_egg_energy_to_person"   // 自动兑换个人蛋蛋能量
	EggEnergyRoutKeyForReadyExchangeGreenEnergyToTeam   = "ready_exchange_egg_energy_to_team"    // 自动兑换团队蛋蛋能量
	EggEnergyRoutKeyForStartExchangeGreenEnergyToTeam   = "start_exchange_egg_energy_to_team"    // 开始兑换团队蛋蛋能量
	EggEnergyRoutKeyForAutoExchangeGreenEnergyToTeam    = "auto_exchange_egg_energy_to_team"     // 自动兑换团队蛋蛋能量

	EggEnergyRoutKeyForSignIn              = "sign_in"                // 签到
	EggEnergyRoutKeyForSignInUpdateRecords = "sign_in_update_records" // 签到更新记录
	EggEnergyRoutKeyForRewardUserCoin      = "reward_user_coin"       // 奖励用户虚拟币

)

type EggEnergyStructForSignIn struct {
	MasterId string `json:"master_id"`
	Uid      int    `json:"uid"`
	Id       int64  `json:"id"`
	EndTime  string `json:"end_time"`
}
type UpdateEggEnergyStructForSignInRecords struct {
	Id  int64 `json:"id"`
	Uid int   `json:"uid"`
}

type EggEnergyStructForStarLevelDividends struct {
	Uid          int64   `json:"uid"`
	SignDividend float64 `json:"sign_dividend"`
}

type EggEnergyStructForStartExchangeGreenEnergy struct {
	Uid                    int64  `json:"uid"`
	Amount                 string `json:"amount"`
	PointCoinId            int    `json:"point_coin_id"`
	EnergyCoinId           int    `json:"energy_coin_id"`
	AutoExchangeNumsAmount string `json:"auto_exchange_nums_amount"`
	StartExchangeTime      string `json:"start_exchange_time"` //发起兑换时间
	EndExchangeTime        string `json:"end_exchange_time"`   //截止兑换时间
}

type EggEnergyStructForAutoExchangeGreenEnergy struct {
	Uid                    int64  `json:"uid"`
	EnergyCoinId           int    `json:"energy_coin_id"`
	AutoExchangeNumsAmount string `json:"auto_exchange_nums_amount"`
	StartExchangeTime      string `json:"start_exchange_time"` //发起兑换时间
	EndExchangeTime        string `json:"end_exchange_time"`   //截止兑换时间
}
